<?php
  include_once('plugin_class_root.inc.php');
  include_once(PHPWG_PLUGINS_PATH.'grum_plugins_classes/tables.class.inc.php');

  /* mypolls class for install process */
  class install_translator extends root_translator
  {
    var $tablef;

    function install_translator($prefixeTable, $filelocation)
    {
      parent::root_translator($prefixeTable, $filelocation);
      $this->tablef= new manage_tables($this->tables);
    }

    /* 
        function for installation process 
        return true if install process is ok, otherwise false 
    */ 
    function install()
    {
      global $user;

      $tables_def=array(
"CREATE TABLE  `".$this->tables['files']."` (
  `id` int(11) NOT NULL auto_increment,
  `type` enum('pwg','plugin') NOT NULL default 'pwg',
  `file` varchar(25) NOT NULL default '',
  `language` varchar(25) NOT NULL default '',
  `version` varchar(10) NOT NULL default '',
  `name` varchar(25) NOT NULL default '',
  `filename` varchar(250) NOT NULL default '',
  `nb_elem` int(11) NOT NULL default '0',
  `nb_ok` int(11) NOT NULL default '0',
  `nb_to_validate` int(11) NOT NULL default '0',
  `nb_to_translate` int(11) NOT NULL default '0',
  `file_date` datetime NOT NULL default '0000-00-00 00:00:00',
  `nb_deleted` int(11) NOT NULL default '0',
  PRIMARY KEY  (`id`),
  UNIQUE KEY `main_key` (`type`,`file`,`language`,`version`, `name`)
) ENGINE=MyISAM COLLATE latin1_general_ci;",

"CREATE TABLE  `".$this->tables['keys']."` (
  `id` varbinary(250) NOT NULL default '',
  `file_id` int(11) NOT NULL default '0',
  `version` int(11) NOT NULL default '0',
  `date` datetime NOT NULL default '0000-00-00 00:00:00',
  `translator` int(11) NOT NULL default '2',
  `status` enum('ok','valide_it','not_translated', 'deleted') NOT NULL default 'not_translated',
  `translation` text NOT NULL,
  `validate_by` int(11) NOT NULL default '0',
  `validate_date` datetime NOT NULL default '0000-00-00 00:00:00',
  `uniqueindex` varchar(32) NOT NULL default '',
  PRIMARY KEY  (`id`,`file_id`,`version`),
  KEY `unique_index` (`uniqueindex`)
) ENGINE=MyISAM COLLATE latin1_general_ci;",

"CREATE TABLE  `".$this->tables['langs']."` (
  `lang_code` char(2) NOT NULL default '',
  `country_code` char(2) NOT NULL default '',
  `charset` varchar(16) NOT NULL default '',
  `direction` enum('ltr','rtl') NOT NULL default 'ltr',
  `name` varchar(25) NOT NULL default '',
  `country` varchar(25) NOT NULL default '',
  `zero_plural` char(1) NOT NULL default 'n',
  `code` varchar(25) NOT NULL default '',
  PRIMARY KEY  (`lang_code`,`country_code`,`charset`)
) ENGINE=MyISAM COLLATE latin1_general_ci;",

"CREATE TABLE  `".$this->tables['langs_codes']."` (
  `code` char(2) NOT NULL default '',
  `name` varchar(25) NOT NULL default '',
  `familly` varchar(25) NOT NULL default '',
  PRIMARY KEY  (`code`)
) ENGINE=MyISAM COLLATE latin1_general_ci;",
      );
      //$table_def array

      $this->init_config();

      $result=$this->modify_functions_user_file();
      if($result=="")
      {
        $result=$this->tablef->create_tables($tables_def);
        if($result)
        {
          $this->load_langs_code();
          $files=$this->search_languages_files("", $this->my_config['charset']);
          foreach($files as $key=>$file)
          {
            $files[$key]=$this->analyze_filename($file);
          }
          $errors=$this->load_lang_files('', '', $files, $user['user_id']);
          //return(print_r($errors, true));
          return($errors);
        }
      }
      return($result);
    }


    /*
        function for uninstall process
    */
    function uninstall()
    {
      $this->delete_config();
      $this->tablef->drop_tables();
      $this->restore_functions_user_file();
    }

    function activate()
    {
      $this->init_config();
      $this->load_config();
      $this->save_config();
    }

    function deactivate()
    {
    }

    function load_langs_code()
    {
      $langs_code=array(
        array('AYMARA', 'AY', 'AMERINDIAN'),
        array('GUARANI', 'GN', 'AMERINDIAN'),
        array('QUECHUA', 'QU', 'AMERINDIAN'),
        array('BHUTANI', 'DZ', 'ASIAN'),
        array('BURMESE', 'MY', 'ASIAN'),
        array('CAMBODIAN', 'KM', 'ASIAN'),
        array('CHINESE', 'ZH', 'ASIAN'),
        array('JAPANESE', 'JA', 'ASIAN'),
        array('KOREAN', 'KO', 'ASIAN'),
        array('LAOTHIAN', 'LO', 'ASIAN'),
        array('THAI', 'TH', 'ASIAN'),
        array('TIBETAN', 'BO', 'ASIAN'),
        array('VIETNAMESE', 'VI', 'ASIAN'),
        array('LATVIAN;LETTISH', 'LV', 'BALTIC'),
        array('LITHUANIAN', 'LT', 'BALTIC'),
        array('BASQUE', 'EU', 'BASQUE'),
        array('BRETON', 'BR', 'CELTIC'),
        array('IRISH', 'GA', 'CELTIC'),
        array('SCOTS GAELIC', 'GD', 'CELTIC'),
        array('WELSH', 'CY', 'CELTIC'),
        array('KANNADA', 'KN', 'DRAVIDIAN'),
        array('MALAYALAM', 'ML', 'DRAVIDIAN'),
        array('TAMIL', 'TA', 'DRAVIDIAN'),
        array('TELUGU', 'TE', 'DRAVIDIAN'),
        array('GREENLANDIC', 'KL', 'ESKIMO'),
        array('INUPIAK', 'IK', 'ESKIMO'),
        array('ESTONIAN', 'ET', 'FINNO-UGRIC'),
        array('FINNISH', 'FI', 'FINNO-UGRIC'),
        array('HUNGARIAN', 'HU', 'FINNO-UGRIC'),
        array('AFRIKAANS', 'AF', 'GERMANIC'),
        array('DANISH', 'DA', 'GERMANIC'),
        array('DUTCH', 'NL', 'GERMANIC'),
        array('ENGLISH', 'EN', 'GERMANIC'),
        array('FAROESE', 'FO', 'GERMANIC'),
        array('FRISIAN', 'FY', 'GERMANIC'),
        array('GERMAN', 'DE', 'GERMANIC'),
        array('ICELANDIC', 'IS', 'GERMANIC'),
        array('NORWEGIAN', 'NO', 'GERMANIC'),
        array('SWEDISH', 'SV', 'GERMANIC'),
        array('YIDDISH', 'YI', 'GERMANIC'),
        array('AFAN (OROMO)', 'OM', 'HAMITIC'),
        array('AFAR', 'AA', 'HAMITIC'),
        array('SOMALI', 'SO', 'HAMITIC'),
        array('ABKHAZIAN', 'AB', 'IBERO-CAUCASIAN'),
        array('GEORGIAN', 'KA', 'IBERO-CAUCASIAN'),
        array('ASSAMESE', 'AS', 'INDIAN'),
        array('BENGALI;BANGLA', 'BN', 'INDIAN'),
        array('BIHARI', 'BH', 'INDIAN'),
        array('GUJARATI', 'GU', 'INDIAN'),
        array('HINDI', 'HI', 'INDIAN'),
        array('KASHMIRI', 'KS', 'INDIAN'),
        array('MARATHI', 'MR', 'INDIAN'),
        array('NEPALI', 'NE', 'INDIAN'),
        array('ORIYA', 'OR', 'INDIAN'),
        array('PUNJABI', 'PA', 'INDIAN'),
        array('SANSKRIT', 'SA', 'INDIAN'),
        array('SINDHI', 'SD', 'INDIAN'),
        array('SINGHALESE', 'SI', 'INDIAN'),
        array('URDU', 'UR', 'INDIAN'),
        array('ALBANIAN', 'SQ', 'INDO-EUROPEAN (OTHER)'),
        array('ARMENIAN', 'HY', 'INDO-EUROPEAN (OTHER)'),
        array('ESPERANTO', 'EO', 'INTERNATIONAL AUX.'),
        array('INTERLINGUA', 'IA', 'INTERNATIONAL AUX.'),
        array('INTERLINGUE', 'IE', 'INTERNATIONAL AUX.'),
        array('VOLAPUK', 'VO', 'INTERNATIONAL AUX.'),
        array('KURDISH', 'KU', 'IRANIAN'),
        array('PASHTO;PUSHTO', 'PS', 'IRANIAN'),
        array('PERSIAN (farsi)', 'FA', 'IRANIAN'),
        array('TAJIK', 'TG', 'IRANIAN'),
        array('GREEK', 'EL', 'LATIN/GREEK'),
        array('LATIN', 'LA', 'LATIN/GREEK'),
        array('HAUSA', 'HA', 'NEGRO-AFRICAN'),
        array('KINYARWANDA', 'RW', 'NEGRO-AFRICAN'),
        array('KURUNDI', 'RN', 'NEGRO-AFRICAN'),
        array('LINGALA', 'LN', 'NEGRO-AFRICAN'),
        array('SANGHO', 'SG', 'NEGRO-AFRICAN'),
        array('SESOTHO', 'ST', 'NEGRO-AFRICAN'),
        array('SETSWANA', 'TN', 'NEGRO-AFRICAN'),
        array('SHONA', 'SN', 'NEGRO-AFRICAN'),
        array('SISWATI', 'SS', 'NEGRO-AFRICAN'),
        array('SWAHILI', 'SW', 'NEGRO-AFRICAN'),
        array('TSONGA', 'TS', 'NEGRO-AFRICAN'),
        array('TWI', 'TW', 'NEGRO-AFRICAN'),
        array('WOLOF', 'WO', 'NEGRO-AFRICAN'),
        array('XHOSA', 'XH', 'NEGRO-AFRICAN'),
        array('YORUBA', 'YO', 'NEGRO-AFRICAN'),
        array('ZULU', 'ZU', 'NEGRO-AFRICAN'),
        array('FIJI', 'FJ', 'OCEANIC/INDONESIAN'),
        array('INDONESIAN', 'ID', 'OCEANIC/INDONESIAN'),
        array('JAVANESE', 'JV', 'OCEANIC/INDONESIAN'),
        array('MALAGASY', 'MG', 'OCEANIC/INDONESIAN'),
        array('MALAY', 'MS', 'OCEANIC/INDONESIAN'),
        array('MAORI', 'MI', 'OCEANIC/INDONESIAN'),
        array('SAMOAN', 'SM', 'OCEANIC/INDONESIAN'),
        array('SUNDANESE', 'SU', 'OCEANIC/INDONESIAN'),
        array('TAGALOG', 'TL', 'OCEANIC/INDONESIAN'),
        array('TONGA', 'TO', 'OCEANIC/INDONESIAN'),
        array('CATALAN', 'CA', 'ROMANCE'),
        array('CORSICAN', 'CO', 'ROMANCE'),
        array('FRENCH', 'FR', 'ROMANCE'),
        array('GALICIAN', 'GL', 'ROMANCE'),
        array('ITALIAN', 'IT', 'ROMANCE'),
        array('MOLDAVIAN', 'MO', 'ROMANCE'),
        array('OCCITAN', 'OC', 'ROMANCE'),
        array('PORTUGUESE', 'PT', 'ROMANCE'),
        array('RHAETO-ROMANCE', 'RM', 'ROMANCE'),
        array('ROMANIAN', 'RO', 'ROMANCE'),
        array('SPANISH', 'ES', 'ROMANCE'),
        array('AMHARIC', 'AM', 'SEMITIC'),
        array('ARABIC', 'AR', 'SEMITIC'),
        array('HEBREW', 'HE', 'SEMITIC'),
        array('MALTESE', 'MT', 'SEMITIC'),
        array('TIGRINYA', 'TI', 'SEMITIC'),
        array('BULGARIAN', 'BG', 'SLAVIC'),
        array('BYELORUSSIAN', 'BE', 'SLAVIC'),
        array('CROATIAN', 'HR', 'SLAVIC'),
        array('CZECH', 'CS', 'SLAVIC'),
        array('MACEDONIAN', 'MK', 'SLAVIC'),
        array('POLISH', 'PL', 'SLAVIC'),
        array('RUSSIAN', 'RU', 'SLAVIC'),
        array('SERBIAN', 'SR', 'SLAVIC'),
        array('SERBO-CROATIAN', 'SH', 'SLAVIC'),
        array('SLOVAK', 'SK', 'SLAVIC'),
        array('SLOVENIAN', 'SL', 'SLAVIC'),
        array('UKRAINIAN', 'UK', 'SLAVIC'),
        array('AZERBAIJANI', 'AZ', 'TURKIC/ALTAIC'),
        array('BASHKIR', 'BA', 'TURKIC/ALTAIC'),
        array('KAZAKH', 'KK', 'TURKIC/ALTAIC'),
        array('KIRGHIZ', 'KY', 'TURKIC/ALTAIC'),
        array('TATAR', 'TT', 'TURKIC/ALTAIC'),
        array('TURKISH', 'TR', 'TURKIC/ALTAIC'),
        array('TURKMEN', 'TK', 'TURKIC/ALTAIC'),
        array('UZBEK', 'UZ', 'TURKIC/ALTAIC'),
        array('BISLAMA', 'BI', '[not given]'),
        array('MONGOLIAN', 'MN', '[not given]'),
        array('NAURU', 'NA', '[not given]')
      );


      foreach($langs_code as $val)
      {
        $sql="INSERT INTO ".$this->tables['langs_codes']." VALUES(
          '".$val[1]."',
          '".$val[0]."',
          '".$val[2]."'
        )";
        $result=pwg_query($sql);
      }
    }

    
    /* this function modify the get_language_filepath inside the
          include/functions_user.inc.php file by replacing a portion of code
        the modifiction consist to return a .lang.phps language file replacing
        a .lang.php file when user is in "translator_mode"

        original pwg file is backup to include/functions_user.inc.php.translator-backup file

        returns "" if sucess, otherwise returns an error message
    */
    function modify_functions_user_file()
    {
      $functions_user=PHPWG_ROOT_PATH."include/functions_user.inc.php";

      if((PHPWG_VERSION == "1.7.0")||(PHPWG_VERSION == "1.7.1"))
      {
        if(copy($functions_user, $functions_user.".translator-backup"))
        {
          $fhandle=fopen($functions_user, "r");
          if($fhandle)
          {
            $body=fread($fhandle, filesize($functions_user));
            fclose($fhandle);

            $search_code = '/[\r\s]*if[\r\s]*\(file_exists\(\$filepath\)\)[\r\s]*\{[\r\s]*return[\r\s]*\$filepath;[\r\s]*\}[\r\s]*/';
            $new_code = '
  /* >>> translator >>> */
    if(isset($user[\'translator_mode\'])&&($user[\'translator_mode\']==\'yes\')&&(file_exists($filepath."s")))
      {
        return $filepath."s";
      }
      elseif (file_exists($filepath))
      {
        return $filepath;
      }
  /* <<< translator <<< */
'; //new code
            $body=preg_replace($search_code, $new_code, $body);

            $fhandle=fopen($functions_user, "w");
            if($fhandle)
            {
              fwrite($fhandle, $body);
              fclose($fhandle);
              return("");
            }
          }
          return(l10n('g001_error_modify_translator'));
        }
        return(l10n('g001_error_copy_backup'));
      }
      return(l10n('g001_error_pwg_version'));
    }

    /*
      this function restore the original include/functions_user.inc.php file
      who is backuped to include/functions_user.inc.php.translator-backup file

      returns "" if sucess, otherwise returns an error message
    */
    function restore_functions_user_file()
    {
      $functions_user=PHPWG_ROOT_PATH."include/functions_user.inc.php";
      if(copy($functions_user.".translator-backup", $functions_user))
      {
        unlink($functions_user.".translator-backup");
        return("");
      }
      $errors=l10n('g001_error_restore_backup');
    }

  } //class

?>
